"use strict";

var _types = require("./types");

var makeTypes = _types.makeTypes;

var _sanctuary = require("sanctuary");

var sanctuary = _interopRequireDefault(_sanctuary).default;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let prod;
prod = /production/i.test(process.env.NODE_ENV);

module.exports = function ($) {
    let types;
    types = makeTypes(sanctuary)($);
    return {
        a: $.TypeVariable("a"),
        b: $.TypeVariable("b"),
        c: $.TypeVariable("c"),
        Fn: function (x) {
            return y => {
                return $.Function([x, y]);
            };
        },
        def: $.create({
            checkTypes: !prod,
            env: $.env.concat(types)
        })
    };
};