"use strict";

var _sanctuary = require("sanctuary");

var prop = _sanctuary.prop;
var ap = _sanctuary.ap;
var flip = _sanctuary.flip;
var singleton = _sanctuary.singleton;
var foldMap = _sanctuary.foldMap;

var _sanctuaryDef = require("sanctuary-def");

var $ = _interopRequireDefault(_sanctuaryDef).default;

var _define = require("./define");

var definitors = _interopRequireDefault(_define).default;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let def, indexBy;
({
  def
} = definitors($));
"/*** @function indexBy* @category List* @memberOf Array#* @sig String -> [Object] -> Object* @param  {String} key String representing the key you want to index by* @return {Object} Hashmap containing all the objects of the array indexed by the `key` property* @example* const indexByName = indexBy ('name')* indexByName([{name:'joe', age: 12 },{name:'peter', age:15}]) * // => {joe: {age: 12, name: 'joe'}, peter: {age: 15, name: 'peter'}}*/";

indexBy = function (key) {
  return foldMap(Object)(ap(flip(singleton))(prop(key)));
};

module.exports = def("sanfu/indexBy")({})([$.String, $.Array($.Object), $.Object])(indexBy);