"use strict";

var _sanctuary = require("sanctuary");

var map = _sanctuary.map;
var prop = _sanctuary.prop;
var insert = _sanctuary.insert;
var ap = _sanctuary.ap;

var _sanctuaryDef = require("sanctuary-def");

var $ = _interopRequireDefault(_sanctuaryDef).default;

var _define = require("./define");

var definitors = _interopRequireDefault(_define).default;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let def, pick;
({
  def
} = definitors($));
"/*** @namespace Object*//*** @function pick* @category Object* @memberOf Object#* @sig [String] -> Object -> Object* @param  {Array<String>} paths list of properties you want to pick* @return {Object} Object containing only the specified properties* @example* const pickNameAge = pick (['age', 'name'])* pickNameAge({ age: 19, name: 'John', zip: 2819, color: 'red', sex: 'male' }) * // => { age: 19 name: 'John' }*/";

pick = function (paths) {
  let getters;
  getters = map(function (path) {
    return function () {
      return insert(path)(prop(path)(...arguments));
    };
  })(paths);
  return function (it) {
    return Object.assign(...ap(ap(getters)([it]))([{}]));
  };
};

module.exports = def("sanfu/pick")({})([$.Array($.String), $.Function([$.Object, $.Object])])(pick);