"use strict";

exports.__esModule = true;
exports.pipeAcc = undefined;

var _define = require("./define");

var definitors = _interopRequireDefault(_define).default;

var _sanctuaryDef = require("sanctuary-def");

var $ = _interopRequireDefault(_sanctuaryDef).default;

var _sanctuary = require("sanctuary");

var unchecked = _sanctuary.unchecked;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let reduce, def, exporting;
({
    reduce
} = unchecked);
({
    def
} = definitors($));

function push_(arr) {
    return x => {
        arr.push(x);
        return arr;
    };
}

function pipeAcc(fns) {
    let acc, reducer;
    acc = push_([]);

    reducer = function reducer(p) {
        return f => {
            return p.then(function () {
                return f(acc(...arguments));
            });
        };
    };

    return function (x) {
        return reduce(reducer)(Promise.resolve(x))(fns);
    };
}

exports.pipeAcc = exporting = def("sanfu/promise/pipeAcc")({})([$.Array($.AnyFunction), $.AnyFunction])(pipeAcc);
exports.pipeAcc = exporting;