"use strict";

exports.__esModule = true;
exports.select = exports.definition = undefined;

var _sanctuary = require("sanctuary");

var prop = _sanctuary.prop;

var _sanctuaryDef = require("sanctuary-def");

var $ = _interopRequireDefault(_sanctuaryDef).default;

var _define = require("./define");

var definitors = _interopRequireDefault(_define).default;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let def, a, select, definition;
({
  def,
  a
} = definitors($));
"/*** @function select* @param  {Any} defaultVal The default value to return if nothing matches* @param  {Object} options An object containing the options to consider* @param  {String} field which field determines the classification of the input object* @param  {Object} item An object to clasify looking at the provided field and searching for it on the options map* @return {Any} The selected option or the default value* @memberOf Object#* @sig a -> StrMap a -> String -> Object -> a* @category Logic* @description * Creates a function that takes an object and selects one value from a map of options or returns the default value.* Please note that it only works on objects, so it is intended to clasify objects or select values based on object's properties* @example* const options = {'Joe':'admin','Daniel':'user'};* const showRole = select ('non-user') (options) ('name')* showRole ({name:'Daniel', age: 18}) // => 'user'* showRole ({name:'NoBody', age: 18}) // => 'non-user'*/";

exports.select = select = function select(defaultVal) {
  return options => field => {
    let p;
    p = prop(field);
    return function (msg) {
      return options[p(msg)] || defaultVal;
    };
  };
};

exports.definition = definition = def("sanfu/select")({})([a, $.StrMap(a), $.String, $.Object, a])(select);
exports.definition = definition;
exports.select = select;