"use strict";

var _sanctuaryDef = require("sanctuary-def");

var $ = _interopRequireDefault(_sanctuaryDef).default;

var _define = require("./define");

var definitors = _interopRequireDefault(_define).default;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let def;
({
  def
} = definitors($));
"/*** General purpose utilities* @namespace Utils*//*** @function tap* @memberOf Utils#* @category Function* @description * ```* tap :: (* -> *) -> a -> a* ```* Wraps a function and returns a new function that will take **any** parameter, pass it to the* wrapped function which return value will be ignored and ther returns the given value.* It could be useful to introduce logging into pipelines and/or execute functions with side effects without interfering the pipeline* @param  {Function} f A function to be wrapped by tap* @param  {Any} x      A value that will be passed to the wrapped function and then returned* @return {Any} Returns the input untouched*/";

function tap(f) {
  return x => {
    f(x);
    return x;
  };
}

module.exports = def("sanfu/tap")({})([$.AnyFunction, $.Any, $.Any])(tap);